<!DOCTYPE html>
<html lang="en">

<head>
  <meta charset="UTF-8">
  <meta name="viewport" content="width=device-width, initial-scale=1.0">
  <meta http-equiv="X-UA-Compatible" content="ie=edge">
  <title>test</title>
</head>

<body>
  <p><em>Psst: have a look at the JavaScript Console</em> 💁</p>
  <script>

    const inventors = [
      { first: 'Albert', last: 'Einstein', year: 1879, passed: 1955 },
      { first: 'Isaac', last: 'Newton', year: 1643, passed: 1727 },
      { first: 'Galileo', last: 'Galilei', year: 1564, passed: 1642 },
      { first: 'Marie', last: 'Curie', year: 1867, passed: 1934 },
      { first: 'Johannes', last: 'Kepler', year: 1571, passed: 1630 },
      { first: 'Nicolaus', last: 'Copernicus', year: 1473, passed: 1543 },
      { first: 'Max', last: 'Planck', year: 1858, passed: 1947 },
      { first: 'Katherine', last: 'Blodgett', year: 1898, passed: 1979 },
      { first: 'Ada', last: 'Lovelace', year: 1815, passed: 1852 },
      { first: 'Sarah E.', last: 'Goode', year: 1855, passed: 1905 },
      { first: 'Lise', last: 'Meitner', year: 1878, passed: 1968 },
      { first: 'Hanna', last: 'Hammarström', year: 1829, passed: 1909 }
    ]


    // 1. Filter the list of inventors for those who were born in the 1500's
    const bornIn1500 = inventor => (inventor.year >= 1500 && inventor.year < 1600)
    const fifteen = inventors.filter(bornIn1500)
    console.log('|--------------- 1')
    console.table(fifteen)

    // 2. Find Lovelace and print  the full object
    // other solution.
    // const findInventorByLastName = name => inventor => (inventor.last === name)

    const findLovelace = inventor => (inventor.last === 'Lovelace')
    const inventorFinIt = inventors.find(findLovelace)

    console.log('|--------------- 2')
    console.log(inventorFinIt)

    // 3. Return a array of objects only  with the prop's first and last
    // other solution.
    const getTheNamesCool = ({ first, last }) => ({ first, last })
    const getTheNames = inventor => ({ first: inventor.first, last: inventor.last })
    const onlyNames = inventors.map(getTheNamesCool)

    console.log('|--------------- 3')
    console.table(onlyNames)

    // 4. Return all the years  of the inventors (sum all the years prop)
    const sum = key => (pre, curr) => (pre + curr[key])
    const years = inventors.reduce(sum('year'), 0)
    console.log('|--------------- 4')
    console.log(years)

    // 5. Return all the  passed sum of the inventors (sum all the passed prop)
    const passed = inventors.reduce(sum('passed'), 0)
    console.log('|--------------- 5')
    console.log(passed)

  </script>
</body>

</html>